#!/usr/bin/env python3
# -*- coding: utf-8 -*-

class Liste:
    """Classe abstraite pour les listes chaînées :
    l’attribut `vide` indique si la liste est vide ;
    on peut obtenir la tête ou la queue d’une liste non vide."""
    def te(self):
        if self.vide:
            raise ValueError("La liste vide n'a pas de tête.")
        return self.tete
    def qu(self):
        if self.vide:
            raise ValueError("La liste vide n'a pas de queue.")
        return self.queue

class Vide(Liste):
    """Classe pour la liste vide."""
    def __init__(self):
        self.vide = True
    def __str__(self):
        return 'Vide()'
        
class Cons(Liste):
    """Classe pour les listes non-vides."""
    def __init__(self, x, u):
        self.vide = False
        self.tete = x
        self.queue = u        
    def __str__(self):
        return f"Cons({self.tete},{self.queue})"
