#!/usr/bin/env python3
# -*- coding: utf-8 -*-
class Pile:
    def __init__(self):
        """Construit une pile vide, dont les valeurs sont stockées
        dans une liste (la tête est le sommet de la pile)."""
        self.valeurs = None
        self.taille = 0
    
    def __str__(self):
        return f"Pile(taille: {self.taille}, valeurs: {self.valeurs})"
    
    def __len__(self):
        return self.taille

    def push(self,x):
        self.valeurs = (x,self.valeurs)
        self.taille += 1

    def pop(self):
        if self.taille == 0:
            raise IndexError("impossible de dépiler un élément d'une pile vide")
        tete, queue = self.valeurs
        self.valeurs = queue
        self.taille -= 1
        return tete