#!/usr/bin/env python3
# -*- coding: utf-8 -*-

def fusion(t1,t2):
    """Fusionne deux tableaux triés."""
    t = []
    i1 = 0
    i2 = 0
    while i1 < len(t1) and i2 < len(t2):
        if t1[i1] < t2[i2]:
            t.append(t1[i1])
            i1 += 1
        else:
            t.append(t2[i2])
            i2 += 1
    if i1 < len(t1):
        for k in range(i1,len(t1)):
            t.append(t1[k])
    else:
        for k in range(i2,len(t2)):
            t.append(t2[k])
    return t

def tri_fusion(t):
    """Retourne une version triée du tableau `t`."""
    if len(t) <= 1:
        return t
    t1 = tri_fusion(t[:len(t)//2])
    t2 = tri_fusion(t[len(t)//2:])
    return fusion(t1,t2)