#!/usr/bin/env python3
# -*- coding: utf-8 -*-

def insere_dans_liste_triee(x,l):
    if l == ():
        return (x,()) # un seul élément: c'est trié
    tete, queue = l
    if x <= tete:
        return (x, l) # `x` est le minimum
    # sinon on insère dans la `queue`
    return (tete, insere_dans_liste_triee(x, queue))

def tri_insertion_liste(l):
    l_triee = ()
    while l != ():
        x, l = l
        l_triee = insere_dans_liste_triee(x, l_triee)
    return l_triee

def liste_triee_vers_tableau(l,n=0):
    if l == ():
        return n*[None]
    t, q = l
    tab = liste_triee_vers_tableau(q,n+1)
    tab[n] = t
    return tab

def tri_insertion(t):
    l = ()
    for x in t:
        l = insere_dans_liste_triee(x, l)
    return liste_triee_vers_tableau(l)

